#include "err.h" 
#include <iostream.h>
#include <fstream.h>
#include <string.h>

void PrintError(int errCode, char* where, char* errlog) {
	char* err;	
	ofstream of(errlog, ios::app);

	switch(errCode) {
	case ERR_NOINIFILE:
		err = "No passwordfile";
		break;
	case ERR_CPULOAD_INTERVAL:
		err = "Incorrect interval";
		break;
	case ERR_PASSWDSIZE:
		err = "Passwordsize";
		break;
	case ERR_NO_SUCH_MESSAGE:
		err = "Unknown messagetype";
		break;
	case ERR_SOCKETINIT:
		err = "Socketinit";
		break;
	case ERR_BIND:
		err = "bind";
		break;	
	case ERR_CREATE_PIPE:		
		err = "CreateNamedPipe";
		break;
	case ERR_CREATE_PROCESS:
		err = "CreateProcess";		
		break;
	case ERR_OPEN_QUERY:
		err = "PdhOpenQuery";
		break;
	case ERR_CONNECT_PIPE:
		err = "ConnectNamedPipe";
		break;
	case ERR_MAKE_COUNTER_PATH:
		err = "PdhMakeCounterPath";
		break;
	case ERR_ADD_COUNTER:
		err = "PdhAddCounter";
		break;
	case ERR_COLLECT_QUERY_DATA:
		err = "PdhCollectQueryData";
		break;
	case ERR_FORMATTED_COUNTER:
		err = "PdhGetFormattedCounterValue";
		break;
	case ERR_BUILD_PROCLIST:
		err = "BuildProcessList";
		break;
	case ERR_CREATE_THREAD:
		err = "CreateThread";
		break;
	case ERR_SOCKET:
		err = "SocketError";
		break;		
	default:
		err = "Unknown";
	}

	cout << "Error in " << where << ": " << err << endl;
	of << "ERROR in " << where << ": " << err << endl;
	of.close();

/*	cout << "Trykk ENTER for aa fortsette/avslutte ";
	char c;
	cin.get(c);*/
}

void PrintSocketError(int errCode, char* where, char* errlog) {

	ofstream of(errlog, ios::app);

	cout << "WSAError: " << errCode << " in " << where << endl;
	of   << "WSAError: " << errCode << " in " << where << endl;
	of.close();

/*	cout << "Trykk ENTER for aa fortsette/avslutte  " << endl;
	char c;
	cin.get(c);*/
}

void PrintOK(char* str, char* errlog) {
	ofstream of(errlog, ios::app);

	of << "OK: " << str << endl;
	of.close();
}
