

#include <windows.h>

#include "common.h"

#include "../../../Common/queries.h"




bool get_total_physical_memory(int& total_memory)
{
	MEMORYSTATUS memstatus;

	GlobalMemoryStatus(&memstatus);

	total_memory = memstatus.dwTotalPhys;

	return true;
}


// get available physical memory on the local machine
bool get_available_physical_memory(int& avail_memory)
{
	MEMORYSTATUS memstatus;

	GlobalMemoryStatus(&memstatus);

	avail_memory = memstatus.dwAvailPhys;

	return true;
}


// get total paged memory on the local machine
bool get_total_paged_memory(int& total_memory)
{
	MEMORYSTATUS memstatus;

	GlobalMemoryStatus(&memstatus);

	total_memory = memstatus.dwTotalPageFile;

	return true;
}


// get available paged memory on the local machine
bool get_available_paged_memory(int& avail_memory)
{
	MEMORYSTATUS memstatus;

	GlobalMemoryStatus(&memstatus);

	avail_memory = memstatus.dwAvailPageFile;

	return true;
}


int CheckMemoryUsage( const KVBuffer& ibuf,
                      KVBuffer& sbuf)
{
  debug("CheckMemoryUsage");

  sbuf.addKeyIntValue("id", MEMUSAGE_QUERY);

  int memory;
  
  if (!get_available_paged_memory(memory))
  {
    return ERR_COLLECT_QUERY_DATA;
  }
  sbuf.addKeyIntValue("free_swap", memory >> 20);
  
  if (!get_total_paged_memory(memory))
  {
    return ERR_COLLECT_QUERY_DATA;
  }
  sbuf.addKeyIntValue("total_swap", memory >> 20);
  
  if (!get_available_physical_memory(memory))
  {
    return ERR_COLLECT_QUERY_DATA;
  }
  sbuf.addKeyIntValue("free_phys", memory >> 20);
  
  if (!get_total_physical_memory(memory))
  {
    return ERR_COLLECT_QUERY_DATA;
  }
  sbuf.addKeyIntValue("total_phys", memory >> 20);

  return NOERR;
}
