
/*
** $Source: \\\\DUMBO\\iris\\riskpro_rcs_sources\\dumbo\\iris\\risk\\src\\MAIN\\purify.cpp,v $
** $Revision: 1.6 $
** $Author: cli $
**
** $Locker:  $
**
** Reviewed:       <Someone>
** Rel. Documents: <To define>
** Short descr:    <To define>
**
** *********************************************************************
** Copyright 1996 - 1999
** IRIS integrated risk management ag (Switzerland)
**
**     Warning:
** This computer program developed by Linkvest SA (Switzerland) for
** IRIS integrated risk management ag is owned fully and exclusively
** by IRIS integrated risk management ag. It is protected by copyright
** law and international treaties. Unauthorized reproduction or use of
** this program or any portion of it, may result in severe civil and
** criminal penalties and will be presented to the maximum extent
** possible under the law.
** *********************************************************************
**
** Revision HISTORY:
**
** $Log: purify.cpp,v $
** Revision 1.6  1999-10-14 10:14:11+02  cli
** Copyright updating (PTS id 2824)
**
** Revision 1.5  1999-08-11 16:21:31+02  fme
** <>
**
** Revision 1.4  1999-08-11 15:09:42+02  fme
** Add purify logging
**
** Revision 1.3  1999-08-11 09:08:14+02  jec
** <>
**
** Revision 1.2  1999-08-10 18:16:06+02  jec
** Made a Purify wrapper with enhanced functions
**
** Revision 1.1  1999-08-10 17:33:49+02  jec
** Initial revision
**
**
** END Revision HISTORY
*/


#include "fndtns/fnstime.h"

#ifndef PurifyINCLUDED
#include "main/purify.h"
#endif

#include "main/pure.h"



IrsInt Purify::nbMinutesBeforeSearch_ = 10;

IrsBoolean Purify::IsRunning()
{
    return PurifyIsRunning();
}

void Purify::FindNewLeaks()
{
    PurifyNewLeaks();
}

void Purify::FindNewLeaksIfNeeded()
{
    FindNewLeaksIfNeeded(nbMinutesBeforeSearch_);
}

void Purify::FindNewLeaksIfNeeded(IrsInt nbMinutes)
{
    static Fn_STime lastSearch = Fn_STime::now();
    if ( (lastSearch + (nbMinutes*60)) < Fn_STime::now() )
    {
        ::PurifyNewLeaks();
        lastSearch = Fn_STime::now();
    }
}

void Purify::Print(const Fn_SString& str)
{
    PurifyPrintf( str.data() );
}
void Purify::PrintAndFindNewLeaksIfNeeded(const Fn_SString& str)
{
    PrintAndFindNewLeaksIfNeeded(str, nbMinutesBeforeSearch_);
}
void Purify::PrintAndFindNewLeaksIfNeeded(const Fn_SString& str, IrsInt nbMinutes)
{
    Print(str);
    FindNewLeaksIfNeeded(nbMinutes);
}

 
/*-------------------------< End of file $RCSfile: purify.cpp,v $ >-------------------------*/
 
